<?php

namespace Lc\SovBundle\Field\Filter;

use Doctrine\ORM\QueryBuilder;
use EasyCorp\Bundle\EasyAdminBundle\Dto\FieldDto;
use Symfony\Component\Form\Extension\Core\Type\IntegerType;
use Symfony\Component\Form\FormBuilderInterface;

/**
 * @author La clic ! <contact@laclic.fr>
 */
class IntegerFilter
{
    use FilterTrait;


    public function buildProperty(FormBuilderInterface $builder, FieldDto $fieldDto,  $options = array())
    {
        $builder->add(
                str_replace('.', '_', $fieldDto->getProperty()),
                IntegerType::class,
                array(
                        'required' => false,
                        'attr' => array(
                                'class' => ' input-sm',
                                'form' => 'filters-form',
                        ),
                )
        );
    }

    public function applyFilter(QueryBuilder $queryBuilder, string $fieldProperty, string $filteredValue= null)
    {
        if ($filteredValue !== null) {
            $queryBuilder->andWhere(
                    'entity.'.$fieldProperty.' = :'.$fieldProperty.''
            );
            $queryBuilder->setParameter($fieldProperty, $filteredValue);
        }
    }

}
